%function [mean,sd]=Aqual2_windowFit(pixels,low,high,optVerbose)
% fit the spectrum of pixels iteratively to find the mean and sd
% as iteration procedes the windows low,high are applied to the 
% data so that only data in the range mean-low*stdev to mean+high*stdev
% are used in the calculation, optVerbose is optional.
function [mean,sd]=Aqual2_windowFit(pixels,low,high,optVerbose)
    if ~exist('optVerbose','var')
        optVerbose=0;
    end
        optVerbose=0;
    pixint=round(pixels);
    pixcenter=mode(pixint);
    pixstd=std(pixels);
    inFit=pixels(pixels>pixcenter-pixstd);
    inFit=inFit(inFit<pixcenter+pixstd);
    result=fit_ML_normal(inFit);
    pixstd=sqrt(result.sig2);
   for iter=1:10
       inFit=pixels(pixels>pixcenter+low*pixstd);
       inFit=inFit(inFit<pixcenter+high*pixstd);
       if length(inFit)<100
	 break;
       end
        if(optVerbose>10)
            result=fit_ML_normal(inFit,'asdf')
        else
            result=fit_ML_normal(inFit);
        end
       
        pixcenter=result.u;
        pixstd=sqrt(result.sig2);
         if(optVerbose>1)
               result
               pixcenter
               pixstd
        end
   end
   mean=pixcenter;
   sd=pixstd;
return;
