function t = EntropyThreshold ( I )
  
% One input argument required.
% Convert all N-D arrays into a single column.  Convert to uint8 for
% fastest histogram computation.
% I = im2uint8(I(:));
I = I(:);

num_bins = max(I) + 1;
counts = hist(I,num_bins);

Zidx = find ( counts == 0 );

% Variables names are chosen to be similar to the formulas in
% the Otsu paper.
p = counts / sum(counts);

pp = p .* log(p);
pp(Zidx) = 0;

for idx = 1:length(pp)
  H(idx) = -sum(pp(1:idx)) + -sum(pp(idx:end) );
end

idx = length(pp):-1:1;
Ha = -cumsum ( pp );
Hmax = max ( Ha );
Hb = -cumsum ( pp(idx) );
Hb = Hmax - Hb;

H = Ha + Hb;

maxval = max ( H );

idx = mean(find(H == maxval));
t = mean ( idx ) + min (I);

