function z=EvalPolyFit(A,X, DEG)
%EvalPolyFit evaluates the polynomial fit, characterized by the matrix A, at
%   arbitrary point X. A is a 125x3 matrix (for fourth-order polynomial
%   fit), and X is a three-element vector containing x,y,z. The polynomial
%   coefficients go with the terms used in defining GRow in EvalRowG.

%The output is a scalar if A is a vector, or a vector with as many columns
%   as A has.

  sz = size ( X );
  z = zeros ( sz );
  for idx = 1:sz(1)
    G = EvalRowG ( X(idx,:), DEG);
    z(idx,:) = G * A;
  end
    
    
