function GRow = EvalRowG(X, DEG)
% GRow output is a row of the G matrix from 'FitSpheres' function. 
% It is also used in Eval function.
% X is a 3-element vector representing an arbitrary point in space

  if (length(X)~=3) 
    disp('ERROR -- LENGTH OF VECTOR IN EvalRowG FUNCTION MUST BE 3');
  end

  % degree of polynomial. Must match what is in FitSpheres function
  % DEG=2;

 % GRow=zeros(1,(DEG+1)^3); %incorrect size
 numTerms=(DEG+1)*(DEG+2)*(DEG+3)/6; %See computation notebood 11/2/05
 Grow=zeros(1,numTerms);

 index=0;
  for m=0:DEG
    for n=0:DEG
      for p=0:DEG
          %GRow(1 + p + n * (DEG + 1) + m * (DEG + 1)^2) = X(1)^m * X(2)^n * X(3)^p;
          if(p+n+m<=DEG) 
              index=index+1;
              GRow(index)=X(1)^m * X(2)^n * X(3)^p;  
          end  
      end
    end
  end


