function  GradWarpCoefficients ( Baseline, Calibration )
% GradWarpCoefficients ( Baseline, Calibration )
% Calculate the GradWarp coefficients and print them out.  For the
% moment, just display...  

  
BaselineSpheresCan = [Baseline.Spheres.CanonicalCOM];
CalibrationSpheresCan = [Calibration.Spheres.CanonicalCOM];

% Put errors in cm
e = 0.1 * ( BaselineSpheresCan - CalibrationSpheresCan );

ex = e(1,:)';
ey = e(2,:)';
ez = e(3,:)';

x = BaselineSpheresCan(1,:)';
y = BaselineSpheresCan(2,:)';
z = BaselineSpheresCan(3,:)';

% Form the A matrix
k = 10;



try
  load GradWarpCoefficients.mat
catch
  % Generate them from 1-10
  for kk = 1:10
    hx = sphericalHarmonics ( kk, 1, 'c', 'cart' );
    hx = strrep ( char ( hx ), '*', '.*' );
    hx = strrep ( char ( hx ), '^', '.^' );
  
    hy = sphericalHarmonics ( kk, 1, 's', 'cart' );
    hy = strrep ( char ( hy ), '*', '.*' );
    hy = strrep ( char ( hy ), '^', '.^' );
  
    hz = sphericalHarmonics ( kk, 0, 'c', 'cart' );
    hz = strrep ( char ( hz ), '*', '.*' );
    hz = strrep ( char ( hz ), '^', '.^' );
    
    Hx{kk} = hx;
    Hy{kk} = hy;
    Hz{kk} = hz;
  end
  save GradWarpCoefficients Hx Hy Hz
end
  


idx = 1;
KRange = 1:2:10;
Ax = zeros ( length ( x ), length ( KRange ) );
Ay = zeros ( length ( x ), length ( KRange ) );
Az = zeros ( length ( x ), length ( KRange ) );

for kk = KRange
  
  Ax(:,idx) = eval ( Hx{kk} );
  Ay(:,idx) = imag ( eval ( Hy{kk} ) );
  Az(:,idx) = eval ( Hz{kk} );
  idx = idx + 1;
  
end

sx = Ax \ ex;
sy = Ay \ ey;
sz = Az \ ez;








