function I = LaplacianOfGaussian ( Image, Sigma, Resolution )
% Do a 3D Laplacian of Gaussion
% Image is the image to filter
% Sigma is the smoothing for the Gaussian (in Resolution units)
% Resolution is the x, y, z resolution
  
% Decide the size of the filter, make sure it's odd
xx = 2 * ceil ( Sigma / Resolution(1) * 3 );
odd = mod ( xx, 2 );
even = 1 - odd;
xx = xx + even;
Center = (xx-1) / 2 + 1;

[X, Y, Z] = meshgrid ( 1:xx, 1:xx, 1:xx );

X = X - Center;
Y = Y - Center;
Z = Z - Center;

Foo = X.^2 + Y.^2 + Z.^2;

LOG = 1 / ( ( 2 * pi )^1.5 * Sigma^7 ) .* exp ( - Foo / ( 2 * Sigma^2 ) ) .* ( -3 * Sigma^2 + Foo );

I = imfilter ( Image, LOG, 'replicate', 'same' );