function A = NormalizedCorrelation3d ( F, T, Mask )
% Brute force calculation of Normalized Correlation, only efficient
% with the Mask argument

% Test
    
  if 0
    Pattern = '/projects/mion/MION/CalibrationData/2005-03-18-ADNITestData//qc_adni_-_nex/2005-05-17/MR15890/Series009/*.dcm';
    [Image, Headers] = LoadDICOMSeriesFast ( Pattern );
    sz = size ( Image );
    Image = Image(1:2:sz(1),1:2:sz(2),1:2:sz(3) );
    SphereRadius = 5;
    BBSize = 3 + SphereRadius;
    resolution = [0.9375    0.9375    1.2000];
    resolution = resolution * 2.0;
    % Make the sphere template for the 10mm (1cm) spheres
    [x,y,z] = meshgrid ( -BBSize:resolution(1):BBSize,  -BBSize:resolution(2):BBSize, -BBSize:resolution(3):BBSize );
    T = sqrt ( x.^2 + y.^2 + z.^2 ) < SphereRadius;
    tic; A = PMNormalizedCorrelation3d ( Image, T ); toc;
  end
  
if ~exist ( 'Mask', 'var' )
  Mask = ones ( size ( F ) );
end

OriginalSize = size(F);
SizeT = size ( T );

% Pad Mask and F
Mask = padarray ( Mask, SizeT, 0, 'both' );
F = int16(padarray ( F, SizeT, 'symmetric', 'both' ));

SizeF = size ( F );
A = zeros ( size ( F ) );

CenterT = floor ( SizeT / 2.0 ) + 1;
WidthT = floor ( SizeT / 2.0 );

T = T - mean(T(:));
T = T / norm ( T(:));

[Tx Ty Tz] = meshgrid ( -WidthT(1):1:WidthT(1),-WidthT(2):1:WidthT(2),-WidthT(3):1:WidthT(3) );
xx = (1:SizeT(1)) - WidthT(1);
yy = (1:SizeT(2)) - WidthT(2);
zz = (1:SizeT(3)) - WidthT(3);

Bounds = [SizeT+1; SizeF-SizeT-1]';

for idx = find ( Mask )'
  [x, y, z] = ind2sub ( size(Mask), idx );
  if x > Bounds(1,1) && x < Bounds(1,2) && y > Bounds(2,1) && y < Bounds(2,2) && z > Bounds(3,1) && z < Bounds(3,2)
    % idx = sub2ind ( SizeF, Tx(:)+x, Ty(:)+y, Tz(:)+z );
    % FNeighboorhood = F((-WidthT(1):1:WidthT(1)) + x,(-WidthT(2):1:WidthT(2)) + y,(-WidthT(3):1:WidthT(3) + z );
    FNeighboorhood = double ( F(xx+x,yy+y,zz+z) );
    FNeighboorhood = FNeighboorhood(:);
    S = sum ( FNeighboorhood );
    if S > 0
      FNeighboorhood = ( FNeighboorhood - S / length ( FNeighboorhood ) );
      A(x,y,z) = sum ( FNeighboorhood .* T(:) ) / norm(FNeighboorhood);
    else
      A(x,y,z) = 0;
    end
  end
end


A = A( SizeT(1):(SizeT(1)+OriginalSize(1)-1), SizeT(2):(SizeT(2)+OriginalSize(2)-1), SizeT(3):(SizeT(3)+OriginalSize(3)-1) );
