function A = PMNormalizedCorrelation3d ( F, T )
% Does normalized correlation on a slice by slice basis

SizeT = size ( T );

pad = [ 0 0 ];
% If T is not odd sized, pad by 1
if ~mod ( SizeT(1), 2 )
  pad(1) = 1;
end
if ~mod ( SizeT(2), 2 )
  pad(2) = 1;
end

T = padarray ( T, pad, 'post' );
SizeT = size ( T );
SizeF = size ( F );


A = zeros ( SizeF );

% Cut back the size
OutStart = floor ( SizeT / 2 );
OutEnd = OutStart + SizeF(1:2) -1;

for ss = 1:SizeF(3)
  TSlice = normxcorr2 ( T, F(:,:,ss) );
  A(:,:,ss) = TSlice(OutStart(1):OutEnd(1), OutStart(2):OutEnd(2) );
end


